#.______________________
#.
#. URL downloading script
#. ESS401 Methodology
#. Lukas Lehotsky
#.
#.______________________


#______________________

# variables ####
#______________________

folder <- "C:\\paste\\path\\to\\folder\\ess401\\" #path to download folder - always use \\

download.list <- "C:\\path\\to\\ess401\\lists\\list.1.txt" #path to list of urls, *.csv or *.txt

soft.src <- "C:\\path\\to\\aria2c.exe" #path to aria software


#______________________

# custom functions ####
#______________________

aria.download <- function(j, soft.src) {
  system(
    
    paste(
      soft.src, #software source
      "", #space for additional parameters (check aria2 manual http://aria2.sourceforge.net/manual/en/html/aria2c.html#options)
      j #file url
      
    ), #compile custom system command
    
    wait = T #argument ensuring non-asynchronous command execution
  ) #function invoking external command
  
} #custom aria.download function

random.time.pause <- function() {
  
  t <- runif(1, #number of random numbers
             min=0, #minimal value
             max=1 #maximal value
             ) #random number generation
  
  Sys.sleep(t)
  print(t) #time break in between downloads to prevent downloader being classified as robot attack
  
} #custom random.time.pause function


#______________________

# workspace setup ####
#______________________

setwd(folder) #set current working directory

dir.create(paste0(folder,"\\downloads\\"), 
           showWarnings = FALSE, 
           recursive = FALSE, 
           mode = "0777") #new files dir

setwd(paste0(folder,"\\downloads\\")) #set new working directory

getwd() #list working directory


#______________________

# import of data from table and create dataframe ####
#______________________

datalist <- read.table(download.list, #variable defining source table
                       header = T, #if TRUE, first line interpreted as data header
                       sep = "\t", #defines data separators (tab is represented as "\t")
                       quote = "\"", #defines quote marks
                       dec = ".", #defines decimal marks
                       fill = T, #if TRUE, in case of uneven data length, blanks implicitly added
                       comment.char = "", #omission of comments in data
                       blank.lines.skip = T #if TRUE, skip empty lines
                       ) #import list of URLs from txt document into dataframe

#NOTE: check whether imported data is correct - whether separators and headers are set correctly - check against the source CSV or TXT files
#NOTE: each of included list files differ - have or don't have headers, have or don't have more variables, have different separators

dim(datalist) #check datalist dimmensions

View(datalist) #view datalist dataset


#______________________

# loop execution ####
#______________________

for (i in datalist$VAR) { #NOTE: don't forget to change variable VAR to one in which URLs are stored - in list.1.txt, it's variable datalist$file.link (open datalist and find out which variables are ones you try to import)
  
  aria.download(i,soft.src)
  
  random.time.pause()
  
}